var _tables=[];
var _view=[];
var _index=[];
var _trigger=[];

function inspectorToggle() {
	if (!_init) return;
	if (_inspector['inspector'].offsetWidth > 0) {
		_inspector['inspector'].style.display='none';
		_inspector['inspectorHider'].style.backgroundImage='url(img/hider_show.gif)';
	}else{
		_inspector['inspector'].style.display='block';
		_inspector['inspectorHider'].style.backgroundImage='url(img/hider.gif)';
	}
	clientResize();
}

function inspectorMenuActionSwitch(e) {
	if (_isIE && !e) e=window.event;
	if (!e) return;
	var eventSrc=(_isIE)?e.srcElement:e.target;
	var div=oFindParentByTagName(eventSrc, 'A');
	if (!div) return;
	var eventType=e.type;
	if (!eventType) return;
	switch (eventType) {
		case 'mouseover':	inspectorMenuOver(e, eventSrc, div, div.data);		break;
		case 'mouseout':	inspectorMenuOut(e, eventSrc, div, div.data);		break;
		case 'click':		inspectorMenuClick(e, eventSrc, div, div.data);		break;
		case 'dblclick':	inspectorMenuDblClick(e, eventSrc, div, div.data);	break;
		case 'mousedown':
			if (e.button == 2) {
				inspectorMenuClick(e, eventSrc, div, div.data);
				inspectorMenuDown(e, eventSrc, div, div.data);
				e.returnValue=false;
			}
		break;
	}
}

function inspectorMenuOver(e, eventSrc, div, data) {
	div.style.borderBottomColor='gray';
}

function inspectorMenuOut(e, eventSrc, div, data) {
	div.style.borderBottomColor='white';
}

var _inspectorCurSelectedMenu=null;
function inspectorMenuClick(e, eventSrc, div, data) {
	if (_inspectorCurSelectedMenu)
		_inspectorCurSelectedMenu.className='';
	_inspectorCurSelectedMenu=div;
	div.className='selected';
	innerText(_inspector['ddl'], inspectorGetDDL(data));

	syntaxSQL(_inspector['ddl']);
}

function inspectorGetDDL(data) {
	var ddl=data.ddl;

	if (data.type == 'table' || data.type == 'view') {
		if (data.type == 'table') {
			for (var i=0; i < _index.length; i++) {
				if (_index[i].table == data.name)
					ddl+="\r\n"+_index[i].ddl;
			}
		}

		for (var i=0; i < _trigger.length; i++) {
			if (_trigger[i].table == data.name)
				ddl+="\r\n"+_trigger[i].ddl;
		}
	}

	return ddl;
}

function inspectorMenuDblClick(e, eventSrc, div, data) {
	if (!data) return;
	boxShow(data);
}

function inspectorMenuDown(e, eventSrc, div, data) {
	inspectorMenu(e, eventSrc, div, data);
}

function inspectorTableListDraw(dbRes) {
	_tables.splice(0, _tables.length);
	_view.splice(0, _view.length);
	inspectorListDraw(dbRes, _tables, 'table', 'Table');
	inspectorListDraw(dbRes, _view, 'view', 'View');
	boxSync(['table', 'view']);
}

function inspectorIndexListDraw(dbRes) {
	_index.splice(0, _index.length);
	inspectorListDraw(dbRes, _index, 'index', 'Index');
	boxSync(['index']);
}

function inspectorTriggerListDraw(dbRes) {
	_trigger.splice(0, _trigger.length);
	inspectorListDraw(dbRes, _trigger, 'trigger', 'Trigger');
	boxSync(['trigger']);
}

function inspectorListDraw(dbRes, arr, type, text) {
	if (dbRes && dbRes.row) {
		for (var i=dbRes.row.length; i--;) {
			if (dbRes.row[i].data[0] == type) {
				if (dbRes.row[i].data[0] == 'table' || dbRes.row[i].data[0] == 'view') {
					arr.push({
						type: type,
						name: dbRes.row[i].data[1],
						ddl: dbRes.row[i].data[2]
					});
					/* XXXXXXXXXXXXXXXXXX *
					if (dbRes.row[i].data[0] == 'table' && dbRes.row[i].data[1] == 'member') {
						_tmp=arr[arr.length-1];
						setTimeout('boxShow(_tmp)', 10);
					}
					/* */
				}else{
					arr.push({
						type: type,
						name: dbRes.row[i].data[1],
						table: dbRes.row[i].data[2],
						ddl: dbRes.row[i].data[3]
					});
				}
			}
		}
	}

	while (_inspector[type].childNodes.length > 0)
		_inspector[type].removeChild(_inspector[type].childNodes[0]);

	_inspector['title_'+type].innerHTML=text+' ('+arr.length+')';
	for (var i=arr.length; i--;) {
		var div=appendNew(_inspector[type], 'A');
		innerText(div, arr[i].name);
		div.data=arr[i];
		arr[i].node=div;
		addEvent(div, 'click', inspectorMenuActionSwitch);
		addEvent(div, 'mouseover', inspectorMenuActionSwitch);
		addEvent(div, 'mouseout', inspectorMenuActionSwitch);
		addEvent(div, 'dblclick', inspectorMenuActionSwitch);
		addEvent(div, 'mousedown', inspectorMenuActionSwitch);
	}
}

function inspectorDdlClear() {
	_inspector['ddl'].innerHTML='';
}

function inspectorContentToggle(link) {
	if (!link || link.tagName != 'H2') return;
	link=oFindParentByTagName(link, 'H2');
	var div=oFindNextSiblingByTag(link, 'DIV');
	if (!div) return;
	if (div.style.display == 'none') {
		div.style.display='block';
		if (_isIE) link.style.filter='';
		else link.style.MozOpacity=1;
	}else{
		div.style.display='none';
		if (_isIE) link.style.filter='alpha(opacity=50)';
		else link.style.MozOpacity=0.5;
	}
}

function inspectorCreate() {
	setTimeout('inspectorCreateShow()', 10);
}

function inspectorCreateShow() {
	inspectorMenu({clientX: 70, clientY: 50}, null, null, {type:'create'});
}

loadJs('inspectorMenu.js');
loadJs('inspectorTable.js');
loadJs('inspectorView.js');
loadJs('inspectorIndex.js');
loadJs('inspectorTrigger.js');
